## org.gnu.gtk
Class Box

    java.lang.Object
      org.gnu.glib.Struct
          org.gnu.glib.GObject
              org.gnu.gtk.GtkObject
                  org.gnu.gtk.Widget
                      org.gnu.gtk.Container
                          org.gnu.gtk.Box

Direct Known Subclasses:
  ButtonBox, HBox, VBox

public class Box
extends Container

This is the base class of HBox and VBox. It has the code necessary to maintain the contained list of widgets, but it does not position them.

Box uses a notion of packing. Packing refers to adding widgets with reference to a particular position in a Container. For a Box, there are two reference positions: the start and the end of the box. For a VBox, the start is defined as the top of the box and the end is defined as the bottom. For a HBox the start is defined as the left side and the end is defined as the right side.

Use repeated calls to `packStart` to pack widgets into a Box from start to end. Use `packEnd` to add widgets from end to start. You may intersperse these calls and add widgets from both ends of the same Box.

Method Summary
`boolean` `getHomogeneous()` Returns whether the box is homogeneous (all children are the same size).
`int` `getSpacing()` Gets the spacing between the children of the box.
`static Type` `getType()` Retrieve the runtime type used by the GLib library.
`void` `packEnd(Widget child)` Adds child to the box, packed with reference to the end of box.
`void` `packEnd(Widget child, boolean expand, boolean fill, int padding)` Adds child to the box, packed with reference to the end of box.
`void` `packStart(Widget child)` Adds child to the box, packed with reference to the start of box.
`void` `packStart(Widget child, boolean expand, boolean fill, int padding)` Adds child to the box, packed with reference to the start of box.
`void` `reorderChild(Widget child, int position)` Moves child to a new position in the list of box children.
`void` `setHomogeneous(boolean homogenous)` Sets the homogeneous field of Box, controlling whether or not all children of box are given equal space in the box.
`void` `setSpacing(int spacing)` Sets the number of pixels to place between children of the box.

Methods inherited from class org.gnu.gtk.Container
`add, addListener, getBorderWidth, getChildren, getEventListenerClass, getEventType, getResizeMode, remove, removeListener, resizeChildren, setBorderWidth, setResizeMode`

Methods inherited from class org.gnu.gtk.Widget

`activate, addAccelerator, addEvents, addListener, addListener, addListener, addListener, addListener, addListener, addListener, addListener, addListener, addListener, addListener, canActivateAccel, createContext, createLayout, draw, drawArea, drawArea, finish, getAccessible, getColormap, getContext, getData, getDisplay, getDragData, getExtensionEvents, getModifierStyle, getName, getParent, getParentWindow, getPointer, getRootWindow, getScreen, getSensitive, getStyle, getToplevel, getWidget, getWindow, grabDefault, grabFocus, hasFocus, hasScreen, hide, hideAll, highlight, highlight, intersect, isAncestor, makeWidget, modifyStyle, popColormap, pushColormap, realize, removeAccelerator, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, removeListener, reparent, setBackgroundColor, setBaseColor, setColormap, setDoubleBuffered, setDragDestination, setDragIcon, setDragIconPixbuf, setDragIconStock, setDragSource, setEvents, setExtensionEvents, setFont, setForegroundColor, setMinimumSize, setName, setNoDragDestination, setNoDragSource, setSensitive, setTextColor, shapeCombineMask, show, showAll, unHighlight, unHighlight`

Methods inherited from class org.gnu.gtk.GtkObject
`destroy, sink`

Methods inherited from class org.gnu.glib.GObject

`addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addListener, collect, freezeNotify, getBooleanProperty, getData, getDoubleProperty, getFloatProperty, getGObjectFromHandle, getIntProperty, getJavaObjectProperty, getLongProperty, getPixbufProperty, getProperty, getStringProperty, hasProperty, notify, removeEventHandler, removeListener, setBooleanProperty, setData, setDoubleProperty, setFloatProperty, setIntProperty, setJavaObjectProperty, setLongProperty, setPixbufProperty, setProperty, setStringProperty, thawNotify`

Methods inherited from class org.gnu.glib.Struct
`equals, getHandle, getNullHandle, hashCode`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### packStart

    public void packStart(Widget child)

  Adds child to the box, packed with reference to the start of box. The child is packed after any other child packed with reference to the start of box. This method takes the default values for expansion, fill and padding.

  Parameters:
    `child` - The widget to be added to the box.

### packStart

    public void packStart(Widget child,
                          boolean expand,
                          boolean fill,
                          int padding)

  Adds child to the box, packed with reference to the start of box. The child is packed after any other child packed with reference to the start of box. This method allows you to define the properties of the packing.

  Parameters:
    `child` - The widget to be added.
    `expand` - TRUE if the new child is to be given extra space allocated to box. The extra space will be divided evenly between all children of box that use this option.
    `fill` - TRUE if space given to child by the expand option is actually allocated to child, rather than just padding it. This parameter has no effect if expand is set to FALSE. A child is always allocated the full height of a HBox and the full width of a VBox. This option affects the other dimension.
    `padding` - Extra space in pixels to put between this child and its neighbors, over and above the global amount specified by spacing in Box. If child is a widget at one of the reference ends of box, then padding pixels are also put between child and the reference edge of Box.

### packEnd

    public void packEnd(Widget child)

  Adds child to the box, packed with reference to the end of box. The child is packed before any other child packed with reference to the end of box. This method takes the default values for expansion, fill and padding.

  Parameters:
    `child` - The widget to be added to the box.

### packEnd

    public void packEnd(Widget child,
                        boolean expand,
                        boolean fill,
                        int padding)

  Adds child to the box, packed with reference to the end of box. The child is packed after any other child packed with reference to the end of box. This method allows you to define the properties of the packing.

  Parameters:
    `child` - The widget to be added.
    `expand` - TRUE if the new child is to be given extra space allocated to box. The extra space will be divided evenly between all children of box that use this option.
    `fill` - TRUE if space given to child by the expand option is actually allocated to child, rather than just padding it. This parameter has no effect if expand is set to FALSE. A child is always allocated the full height of a HBox and the full width of a VBox. This option affects the other dimension.
    `padding` - Extra space in pixels to put between this child and its neighbors, over and above the global amount specified by spacing in Box. If child is a widget at one of the reference ends of box, then padding pixels are also put between child and the reference edge of Box.

### setHomogeneous

    public void setHomogeneous(boolean homogenous)

  Sets the homogeneous field of Box, controlling whether or not all children of box are given equal space in the box.

  Parameters:
    `homogenous` - A boolean value, TRUE to create equal allotments, FALSE for variable allotments.

### getHomogeneous

    public boolean getHomogeneous()

  Returns whether the box is homogeneous (all children are the same size).

  Returns:
    TRUE if the box is homogeneous.
  See Also:
    `setHomogeneous(boolean)`

### setSpacing

    public void setSpacing(int spacing)

  Sets the number of pixels to place between children of the box.

  Parameters:
    `spacing` - The number of pixels to put between children.

### getSpacing

    public int getSpacing()

  Gets the spacing between the children of the box.

  Returns:
    Spacing between children

### reorderChild

    public void reorderChild(Widget child,
                             int position)

  Moves child to a new position in the list of box children.

  A widget's position in the box children list determines where the widget is packed into box. A child widget at some position in the list will be packed just after all other widgets of the same packing type that appear earlier in the list.

  Parameters:
    `child` - The widget to move
    `position` - The new position for child in the box, starting from 0. If negative, the end of the list is used.

### getType

    public static Type getType()

  Retrieve the runtime type used by the GLib library.